<template class="align-center">
  <v-main align-center justify-center class="py-5 height-full">
    <v-row justify="center" align="center" class="pt-6">
      <v-col cols="10" xs="12" sm="7" md="6" lg="4">
        <h2>{{ $t('btnpassword') }}</h2>
        <v-form
          id="sendEmailPassword"
          ref="form"
          v-model="valid"
          class="pt-6"
          @submit.prevent="sendEmailVerificationSengrid('resetPassword', email)"
        >
          <v-text-field
            id="login_email"
            v-model="email"
            :rules="rulesEmail"
            type="email"
            :label="$t('email')"
            required
            outlined
          ></v-text-field>
          <v-col cols="12" justify="center" align="center">
            <div id="recaptcha-password-reset" class="recaptcha"></div>
          </v-col>
          <v-col cols="12" xs="12" class="px-0">
            <v-btn
              id="save-user"
              :disabled="!valid || loading"
              block
              type="submit"
              color="primary"
              class="white--text"
            >
              {{ $t('send') }}
            </v-btn>
          </v-col>
        </v-form>
      </v-col>
    </v-row>
    <v-snackbar
      v-model="snackbar.show"
      :top="true"
      :right="true"
      :timeout="snackbar.timeout"
      :color="snackbar.color"
      :multi-line="snackbar.mode === 'multi-line'"
      :vertical="snackbar.mode === 'vertical'"
    >
      {{ snackbar.text }}
      <v-btn
        icon
        class="float-right"
        justify="center"
        align="center"
        @click.native="snackbar.show = false"
      >
        <v-icon>mdi-close</v-icon>
      </v-btn>
    </v-snackbar>
  </v-main>
</template>

<script lang="ts">
import Vue from 'vue'
import SendEmailVerificationMixin from '~/mixins/SendEmailVerificationMixin'

declare global {
  interface Window {
    recaptchaVerifierResetPassword: any
    recaptchaWidgetResetPasswordId: any
  }
}

export default Vue.extend({
  components: {},
  mixins: [SendEmailVerificationMixin],
  data() {
    return {
      valid: false,
      rulesEmail: [
        (v: string) => !!v || 'El campo es requerido',
        (v: string) =>
          !v ||
          /^[-\w.%+]{1,64}@(?:[A-Z0-9-]{1,63}\.){1,125}[A-Z]{2,63}$/i.test(v) ||
          'Ingresa un email válido',
      ],
      email: '',
      reCAPTCHAResetPassword: false,
    }
  },
  mounted() {
    const self = this
    window.recaptchaVerifierResetPassword =
      new self.$fireModule.auth.RecaptchaVerifier('recaptcha-password-reset', {
        callback() {
          // eslint-disable-next-line @typescript-eslint/no-unused-vars
          return new Promise<string | void>((resolve, reject) => {
            self.reCAPTCHAResetPassword = true
            resolve()
          })
        },
        'expired-callback': () => {
          // eslint-disable-next-line @typescript-eslint/no-unused-vars
          return new Promise<string | void>((resolve, reject) => {
            self.reCAPTCHAResetPassword = false
          })
        },
        size: this.$vuetify.breakpoint.smAndDown ? 'compact' : 'normal',
      })
    window.recaptchaVerifierResetPassword
      .render()
      .then(function (widgetId: any) {
        window.recaptchaWidgetResetPasswordId = widgetId
      })
  },
})
</script>

<style scoped>
.height-full {
  height: 100%;
}
</style>
